#!/usr/bin/env python2
# -*- coding: utf8 -*-

import sys
import pickle
import random
import re
import json
import gmpy2
from pwn import *

def attack(ip, t_id, t_name):
    c = remote(ip, 65533)
    c.recvuntil('Welcome to the Temperature Sensor Station! What would you like to do?')

    for i in range(10):
        # query room to get encrypted flags
        c.sendline('2')
        # select room
        c.sendline(str(i+1))

        raw_data = c.recvuntil('Welcome to the Temperature Sensor Station! What would you like to do?', drop=True)
        enc_flags = re.findall(r'.*?\t(.*)\n', raw_data)

        for ef in enc_flags:
            try:
                enc = base64.b64decode(ef)
                num = unpack(enc, word_size=len(enc)*8, endianness='big')
                root, perfect = gmpy2.iroot(num,3)
                if perfect:
                    flag = pack(int(root), word_size='all', endianness='big')
                    print(flag)
            except:
                pass

def main():
    if len(sys.argv) < 4:
        log.warn('Nope, usage: ./script.py <ip> <id> <name>')
        sys.exit(1)

    ip = sys.argv[1]
    t_id = sys.argv[2]
    t_name = sys.argv[3]

    attack(ip, t_id, t_name)
    sys.exit(0)

if __name__ == '__main__':
    main()

